<template>
  <div class="modal-container">
    <div class="modal-header">
      <p class="modal-title">{{ $t('otp.modal.title') }}</p>
      <button type="button" @click="closeModal()" class="btn-close"><span aria-hidden="true">×</span></button>
    </div>
    <div class="modal-body">
      <div class="otp-step">
        <div :class="`${isCurrentStep(step) ? 'active': ''} step-${step.step} step`" @click="selectStep(step)" v-for="step in steps">
          <span>{{ $t('otp.modal.step', {step: step.step}) }}</span>
        </div>
      </div>
      <div class="otp-step-container">
        <p class="otp-title">{{ $t('otp.modal.step', {step: current.step}) }}. {{ $t(current.title) }}</p>
        <component v-for="(step, index) in steps" :key="index" :is="step.component" @previous="prevStep()" @next="nextStep()" v-show="isCurrentStep(step)"></component>
      </div>
    </div>
  </div>
</template>

<script>
import Install from './Install.vue';
import QR from './QR.vue';
import BackupKey from './BackupKey.vue';
import EnableAuthentication from './EnableAuthentication.vue';

export default {
  data() {
    return {
      steps: [
        {
          step: 1,
          isPassed: true,
          title: 'otp.modal.step1.title',
          component: 'Install',
        },
        {
          step: 2,
          isPassed: false,
          title: 'otp.modal.step2.title',
          component: 'QR',
        },
        {
          step: 3,
          isPassed: false,
          title: 'otp.modal.step3.title',
          component: 'BackupKey',
        },
        {
          step: 4,
          isPassed: false,
           title: 'otp.modal.step4.title',
          component: 'EnableAuthentication',
        },
      ],
      current: {},
    }
  },
  components: {
    Install,
    QR,
    BackupKey,
    EnableAuthentication,
  },
  methods: {
    isCurrentStep (step) {
      return this.current.step === step.step;
    },
    selectStep (step) {
      if (step.isPassed && !this.isCurrentStep(step)) {
        this.current = step;
      }
    },
    nextStep() {
      const nextStep = this.current.step + 1;
      const current = this.steps.find(step => step.step === nextStep);
      current.isPassed = true;
      this.current = current;
    },
    prevStep() {
      const prevStep = this.current.step - 1;
      this.current = this.steps.find(step => step.step === prevStep);
    },
    closeModal() {
      this.$broadcast('close-modal');
    },
  },
  created () {
    this.current = this.steps[0];
  },
};
</script>

<style lang="scss" scoped>
  @import '../../../../sass/_variables.scss';

  * {
    font-family: $font-family-home;
  }
  .modal-container {
    width: 800px;
    min-height: 500px;
    margin: auto;
    background-color: #f7f7f7;
    border-radius: 7px;
    transition: all .3s ease;
    box-shadow: 0 2px 40px 0 rgba(0, 0, 0, 0.18);
    @media screen and (max-width: 768px){
      width: 750px;
      .otp-step {
        .step {
          width: 187px !important;
          &.step-1 {
            width: 189px !important;
          }
        }
      }
    }
    .modal-header {
      padding: 0;
      border: none;
      position: relative;
      .modal-title {
        font-size: 18px;
        font-weight: bold;
        color: #1c1c1c;
        padding-left: 60px;
        padding-top: 40px;
      }
      .btn-close {
        width: 30px;
        height: 30px;
        background-color: $bg_white;
        border: 1px solid $white;
        border-radius: 50%;
        outline: none;
        top: 35px;
        right: 15px;
        position: absolute;
        span {
          cursor: pointer;
          color: $thin_gray;
          font-size: 17px;
        }
      }
    }
    .modal-body {
      padding: 0;
      margin: 30px 0 0 0;
      height: 350px;
      position: relative;
      .otp-step {
        display: inline-block;
        .step {
          width: 205px;
          float: left;
          height: 50px;
          display: table;
          position: relative;
          cursor: pointer;
          &:after {
            position: absolute;
            z-index: 2;
            height: 0;
            width: 0;
            right: -15px;
            border-width: 25px 0 25px 15px;
            border-style: solid;
          }
          &.active {
            background-color: $dark_orange !important;
            span {
              color: $white !important;
            }
            &:after {
              border-color: transparent transparent transparent $dark_orange !important;
            }
          }
          &.step-1 {
            width: 185px;
            background-color: #ededed;
            &:after {
              border-color: transparent transparent transparent #ededed;
              content: '',
            }
          }
          &.step-2 {
            background-color: #e5e5e5;
            &:after {
              border-color: transparent transparent transparent #e5e5e5;
              content: '',
            }
          }
          &.step-3 {
            background-color: #dbdbdb;
            &:after {
              border-color: transparent transparent transparent #dbdbdb;
              content: '',
            }
          }
          &.step-4 {
            background-color: #d3d3d3;
          }
          span {
            text-transform: uppercase;
            padding-left: 5px;
            font-size: 12px;
            font-weight: bold;
            font-style: normal;
            font-stretch: normal;
            letter-spacing: 0.5px;
            text-align: center;
            color: $gray;
            display: table-cell;
            vertical-align: middle;
          }
        }
      }
      .otp-step-container {
        margin: 40px 60px;
        .otp-title {
          font-size: 16px;
          font-weight: bold;
          font-style: normal;
          font-stretch: normal;
          line-height: normal;
          letter-spacing: normal;
          color: $black;
        }
      }
    }
  }
</style>
<style lang="scss">
  @import '../../../../sass/_variables.scss';
  .clearfix {
    clear: both;
  }
  .btn-next-step {
    width: 120px;
    border: solid 1px #da6400;
    color: $white;
  }
  .btn-step {
    height: 32px;
    border-radius: 30px;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    letter-spacing: 0.5px;
    text-align: center;
    text-transform: uppercase;
    padding: 0;
    outline: none;
    cursor: pointer;
    background-color: $orange;
    &:hover {
      background: $dark_orange;
      color: white;
    }
    i {
      font-family: FontAwesome;
      font-size: 14px;
      font-weight: bold;
    }
  }
  .btn-prev-step {
    width: 145px;
    border: solid 1px $orange;
    background: transparent;
    color: #fa7300;
  }
  .btn-step {
    outline: none;
  }
</style>
